-- compute the Adler-32 checksum of a sequence of bytes
-- Copyright (C) 1995-2002 Mark Adler
-- converted to euphoria by Paul Plummer

global function adler_32(sequence buf)
integer s1
integer s2
sequence adler_out
adler_out={0,0,0,0}
s1=1
s2=0
for c=1 to length(buf) do
s1=remainder(s1+buf[c],65521)
s2=remainder(s2+s1,65521)
end for
adler_out[1]=floor(s2/256)
adler_out[2]=and_bits(s2,255)
adler_out[3]=floor(s1/256)
adler_out[4]=and_bits(s1,255)
return adler_out
end function

