include gifload.e
include wildcard.e
include ez_write.e
include readfile.e
include zigload.e

object input
sequence commands,fname,fname2,ext,pal,image,buffer
integer test,fn,x,y,fn2

procedure usage()
puts(1,"Converts bmp or gif to zig (zipped graphic format)\n")
puts(1,"Converts zig to bmp\n")
puts(1,"Usage: ex iconvert inputfile_name\n")
puts(1,"inputfile_name must have extension .bmp .gif or .zig\n")
abort(1)
end procedure

commands=command_line()
if length(commands)=3 then
  fname=lower(commands[3])
  test=find('.',fname)
    if test then
      ext=fname[test+1..length(fname)]
        if equal(ext,"zig") then
        fname2=fname[1..test]&"bmp"
        input=read_zig(fname)
          if atom(input) then
            puts(1,ZIG_ERROR_STRING()&"\n")
            abort(1)
          end if
        test=save_bitmap(input,fname2)
if test then
            puts(1,"save_bitmap failed!\n")
            abort(1)
else
        puts(1,fname2&" created\n")
end if        
        elsif equal(ext,"bmp") or equal(ext,"gif") then
        fname2=fname[1..test]&"zig"
          if equal(ext,"bmp") then
            input=read_bitmap(fname)  
            if atom(input) then
              if input=3 then
                puts(1,"Unsupported bitmap\n")
                abort(1)
              else
                puts(1,"read_bitmap failed!\n")
                abort(1)
              end if
            end if
          end if
          if equal(ext,"gif") then
            input=read_gif(fname)  
          if atom(input) then
            puts(1,"read_gif failed!\n")
            abort(1)
          end if
          end if


pal=input[1]
image=input[2]
x=length(image[1])
y=length(image)
fn=open(fname2,"wb")
buffer="ZIG"
puts(fn,buffer)
buffer=int_to_bytes(length(pal))
puts(fn,buffer[1..2])
buffer=int_to_bytes(x)
puts(fn,buffer[1..2])
buffer=int_to_bytes(y)
puts(fn,buffer[1..2])
fn2=open("test.$$$","wb")
for c=1 to length(pal) do
buffer=pal[c]
puts(fn2,buffer)
end for
for c=1 to y do
buffer=image[c]
puts(fn2,buffer)
end for
close(fn2)
create_ez_file("$$$.zd",{"test.$$$"},{"image"},{0})
          if EZ_WRITE_ERROR() then
puts(1,EZ_WRITE_ERROR_STRING()&"\n")
            abort(1)
          end if

buffer=read_file("$$$.zd")
puts(fn,buffer)
close(fn)
system("del test.$$$",2)
system("del $$$.zd",2)
puts(1,fname2&" created\n")

          
        else
        usage()    
        end if
    else
      usage()
    end if
else
usage()
end if

