--Write ezip data files - Paul Plummer
--requires zip16.exe to be in path


--  ezip data format  (n)=n bytes    example 2 entries

--(2)DS (1)length_file_name1 (?)file_name_string1 (1)ftype1 
--(4)Uncompressed_length1 (4)Compressed_length1 (?)compressed_data1
--(1)length_file_name2 (?)file_name_string2 (1)ftype2 (4)Uncompressed_length2 (4)Compressed_length
--(?)compressed_data2 (1)0 (4)total_length_of_data (2)DE

include zdata.e
include ez_error.e
include ez_read.e
--include misc.e
global constant FN=0,SQ=1,SQB=2
global procedure create_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes)
--zname - string - name for zipdata file
--inputs - sequence of (filenames or sequences)
--dnames - sequence of (names to access data)
--ftypes - sequence of types (filename)=0 (sequence)=1 (sequence of bytes)=2

integer fn,length_data
sequence data,buffer
if length(dnames)=0 then
dnames=inputs    
end if
length_data=0
buffer="DS"
fn=open(zname,"wb")
if fn=-1 then 
EZ_ERROR=8   --file create error  
return 
end if
puts(fn,buffer)
length_data+=2
for c=1 to length(inputs) do
buffer=(dnames[c])
puts(fn,length(buffer))
puts(fn,buffer)
length_data+=length(buffer)+1
data=deflate_seq(inputs[c],ftypes[c])
--if length(data)=1 then  --deflate error
if EZ_ERROR then  --deflate error
close(fn)
system("del "&zname,2)
return
end if
puts(fn,data) 
length_data+=length(data)
end for
puts(fn,0)  
length_data+=1
buffer=int_to_bytes(length_data)
puts(fn,buffer)  
buffer="DE"
puts(fn,buffer)
close(fn)
EZ_ERROR=0
return  --no error
end procedure


global procedure remove_ez_file(sequence zname,sequence rnames)
sequence test,buffer
integer ok,fn,junk,length_data,offset,fn2,extra
test=ez_info(zname)
fn=open(zname,"rb")
fn2=open("$$$.dd","wb")
length_data=0
buffer="DS"
puts(fn2,buffer)
length_data+=2

for c=1 to length(test) do
ok=1
for cc=1 to length(rnames) do
if equal(rnames[cc],test[c][1]) then
ok=0    
end if

end for
if ok then
offset=test[c][2][1]
extra=length(test[c][1])+1
offset-=extra
junk=seek(fn,offset)
buffer=get_bytes(fn,test[c][2][4]+extra+9)
puts(fn2,buffer)
length_data+=length(buffer)
end if
end for
puts(fn2,0)  
length_data+=1
buffer=int_to_bytes(length_data)
puts(fn2,buffer)  
buffer="DE"
puts(fn2,buffer)
flush(fn2)
close(fn2)
close(fn)
system("del "&zname,2)
system("ren $$$.dd "&zname,2)
end procedure

procedure add_or_update_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes,integer atype)
--atype 0=add 1=update
sequence test,buffer,data,rnames
integer ok,fn,junk,file_end,length_data
test=ez_info(zname)
if EZ_ERROR then   --zname probably does not exist create file
EZ_ERROR=0
create_ez_file(zname,inputs,dnames,ftypes)
return
else
ok=1
rnames={}
for c=1 to length(dnames) do
for cc=1 to length(test) do
if equal(dnames[c],test[cc][1]) then
ok=0    
rnames=append(rnames,dnames[c])
end if
end for
end for
if not(ok) then
if atype then
remove_ez_file(zname,rnames) --update     
else
EZ_ERROR=22    --dname already exists    --add only
return    
end if
end if
fn=open(zname,"ub")
if fn=-1 then 
EZ_ERROR=21   --file open error  
end if
junk=seek(fn,-1)  
file_end=where(fn)
junk=seek(fn,file_end-6)
buffer=get_bytes(fn,4)
length_data=bytes_to_int(buffer)
length_data-=1 --remove end of data byte
junk=seek(fn,file_end-7)

for c=1 to length(inputs) do
buffer=(dnames[c])
puts(fn,length(buffer))
puts(fn,buffer)
length_data+=length(buffer)+1
data=deflate_seq(inputs[c],ftypes[c])
--if length(data)=1 then  --deflate error
if EZ_ERROR then  --deflate error
close(fn)
system("del "&zname,2)
return
end if
puts(fn,data) 
length_data+=length(data)
end for
puts(fn,0)  
length_data+=1
buffer=int_to_bytes(length_data)
puts(fn,buffer)  
buffer="DE"
puts(fn,buffer)
close(fn)
EZ_ERROR=0
return  --no error
end if    
end procedure

global procedure update_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes)
add_or_update_ez_file(zname,inputs,dnames,ftypes,1)
end procedure

global procedure add_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes)
add_or_update_ez_file(zname,inputs,dnames,ftypes,0)
end procedure

global function EZ_WRITE_ERROR_STRING()
if EZ_ERROR=0 then
return "No errors"
else
return EZ_ERROR_STRING[EZ_ERROR]    
end if
end function

global function EZ_WRITE_ERROR()
return EZ_ERROR    
end function

global procedure CLEAR_WRITE_ERROR()
EZ_ERROR=0    
end procedure

