include rfont.e
include mouse.e
include image.e
include graphics.e
include sort.e
include button.e
include file.e
include bget.e
include cards.e

sequence deck,card,tseq,ecards,hands,scoring,suits,values,sscore
sequence hand,timage,standard_size,player
object mevent,hscore
integer test,x,y,crd,tmp,cnt,event,count,tx,ty,score,fn
integer fflush,straight,royal,four_kind,three_kind,full_house,pair,two_pair
integer oscore
standard_size={100,30}
oscore=0
event=0
test=ismouse()
if test=0 then
puts(1,"This program requires a mouse\n")
abort(2)
end if
count=1
player={}
scoring={0,5,15,20,30,35,45,60,100,500}
deck={}
for c=1 to 52 do
deck=deck&c
end for
hscore=dir("psqscore.dat")
if atom(hscore) then
fn=open("psqscore.dat","wb")
hscore={}
for c=1 to 10 do
hscore=append(hscore,{0,"Empty"})
end for
bprint(fn,hscore)
close(fn)
else
fn=open("psqscore.dat","rb")
hscore=bget(fn)
hscore=hscore[2]
close(fn)
end if
procedure help()
sequence message
message={"Scoring",
         "Royal Flush     500",
         "Straight Flush  100",
         "Four of a kind   60",
         "Full House       45",
         "Flush            35",
         "Straight         30",
         "Three of a kind  20",
         "Two pair         15",
         "Pair              5"}
test=mbox({232,120},{168,240},message,{6,7},{"More","OK"})
if test=6 then
message={"How to Play",
         " ",
         "Try to create the best    ",
         "poker hands horizontally, ",
         "vertically or diagonally  ",
         " ",
         "The card that is up is the",
         "large card on the right   ",
         " ",
         "click card backs to place "}
test=mbox({196,120},{232,240},message,{6,7},{"More","OK"})
if test=6 then
message={"Royal Flush - all cards same suit sequence 10 to ace        ",
         "Straight Flush - all cards same suit in sequence            ",
         "Four of a kind - four cards of the same value               ",
         "Full House - three cards same value and two cards same value",
         "Flush - all cards same suit                                 ",
         "Straight - all cards in sequence                            ",
         "Three of a kind - three cards of the same value             ",
         "Pair - two cards of the same value                          ",
         "Two pair - two sets of pairs                                "}
test=mbox({68,120},{504,240},message,{6,7},{"More","OK"})
if test=6 then
message={"This program was created by Paul Plummer.    ",
         " ",
         "It was created with the programming lauguage ",
         "Euphoria version 2.3 .                       ",
         "Card graphics compressed with Ezip.          ",
         " ",
         "Euphoria is an easy to learn interpretive    ",
         "language similar to basic with with some     ",
         "elements of the C language.                  ",
         " ",
         "Obtain a free copy from www.RapidEuphoria.com",
         " ",
         "Create 32-bit Dos, Win32 or Linux programs   "}
test=mbox({128,120},{384,240},message,{6},{"OK"})

end if
         
end if
end if
end procedure

procedure high_score()
sequence message,name,sscore
message={}
for c=1 to 10 do
name=hscore[c][2]
sscore=sprintf("%d",hscore[c][1])
if length(name)>20 then
name=name[1..20]
end if
if length(name)<20 then
for cc=1 to 20-length(name) do
name=name&' '
end for
end if
for cc=1 to 6-length(sscore) do
sscore=' '&sscore
end for
name=name&sscore
message=append(message,name)
end for
test=mbox({196,120},{232,240},message,{6},{"OK"})
end procedure

procedure shuffle()
for c=1 to 52 do
crd=rand(52)
tmp=deck[c]
deck[c]=deck[crd]
deck[crd]=tmp
end for
cnt=1
ecards=repeat(repeat(-1,5),5)
end procedure

function ghand(sequence  thand)
if thand[5]=-1 then return {} end if
if thand[4]=-1 then return {} end if
if thand[3]=-1 then return thand[4..5] end if
if thand[2]=-1 then return thand[3..5] end if
if thand[1]=-1 then return thand[2..5] end if
return thand
end function


procedure tscore()
integer tcount
score=0
for c=1 to 12 do
while 1 do
fflush=0 straight=0 royal=0 four_kind=0
three_kind=0 full_house=0 pair=0 two_pair=0
--flush
hand=ghand(values[c])
if length(hand)<2 then exit end if
if length(hand)=2 then
if hand[1]=hand[2] then
  score+=5  --pair
  exit 
else
exit
end if
end if
if length(hand)=3 then
  if hand[1]=hand[2] then
    if hand[2]=hand[3] then
      score+=20 --3kd
      exit
    else
      score+=5  --pair
      exit 
    end if
  else
    if hand[2]=hand[3] then
      score+=5  --pair
      exit 
    end if
        if hand[1]=hand[3] then
      score+=5  --pair
      exit 
     else
      exit
    end if
  end if 
end if

if length(hand)=4 then
  if hand[1]=hand[2] then
    if hand[2]=hand[3] then
      if hand[3]=hand[4] then
        score+=60  --4kd
        exit
      else
        score+=20  --3kd
        exit
      end if
    else
      if hand[3]=hand[4] then
        score+=15   --two pair
        exit
      else
        score+=5  --pair
        exit
      end if

    end if
  else
    if hand[2]=hand[3] then
      if hand[3]=hand[4] then
        score+=20   --3kd
        exit
      else
        score+=5    --pair
      end if
    else
      if hand[3]=hand[4] then
        score+=5    --pair
        exit
      else
        exit
      end if
    end if
  end if
end if




tmp=suits[c][1]
tcount=1
for cc=2 to 5 do
if tmp=suits[c][cc] then
tcount+=1
end if
end for
if tcount=5 then
fflush=1
end if
--straight
tmp=values[c][1]
tcount=1
for cc=2 to 5 do
if values[c][cc]=tmp+cc-1 then
tcount+=1
end if
end for
if tcount=5 then
straight=1
end if
if fflush=1 and straight=1 then
--royal
if values[c][1]=10 then
royal=1
end if
end if
if royal=1 then
score+=500
exit
end if
if fflush=1 and straight=1 then
score+=100
exit
end if
if straight=1 then
score+=30
exit
end if
--4kd
if values[c][1]!=values[c][2] then
tseq=values[c]
values[c][5]=tseq[1]
values[c][1]=tseq[2]
values[c][2]=tseq[3]
values[c][3]=tseq[4]
values[c][4]=tseq[5]
end if
if values[c][1]!=values[c][2] then
tseq=values[c]
values[c][5]=tseq[1]
values[c][1]=tseq[2]
values[c][2]=tseq[3]
values[c][3]=tseq[4]
values[c][4]=tseq[5]
end if
if values[c][1]!=values[c][2] then
tseq=values[c]
values[c][5]=tseq[1]
values[c][1]=tseq[2]
values[c][2]=tseq[3]
values[c][3]=tseq[4]
values[c][4]=tseq[5]
end if
tmp=values[c][1]
tcount=1
for cc=2 to 5 do
if values[c][cc]=tmp then
tcount+=1
end if
end for
if tcount=4 then
four_kind=1
score+=60
exit
end if
if tcount=3 then
three_kind=1
end if
--fullhouse
if three_kind=1 then
  if values[c][4]=values[c][5] then
    score+=45
    exit
  else
    if fflush!=1 then
      score+=20 --3kd
      exit
    else
      score+=35 --flush
      exit
    end if
  end if
end if
if tcount=2 then
  if values[c][3]=values[c][4] then
    if values[c][4]=values[c][5] then
    score+=45  --full house
    exit
    else
    score+=15  --two pair
    exit
    end if
  elsif values[c][4]=values[c][5] then
    score+=15  --two pair
    exit
  else  
  score+=5  --pair
  exit 
  end if
end if
if tcount=1 then
if values[c][2]=values[c][3] then
  score+=5  --pair
  exit 
end if
if values[c][3]=values[c][4] then
  score+=5  --pair
  exit 
end if
if values[c][4]=values[c][5] then
  score+=5  --pair
  exit 
end if
end if
exit
end while
end for
end procedure

procedure eval()
hands=repeat(repeat(0,5),12)
suits=repeat(repeat(0,5),12)
values=repeat(repeat(0,5),12)
for c=1 to 5 do
hands[c]=sort(ecards[c])
hands[c+5]=sort({ecards[1][c],ecards[2][c],ecards[3][c],ecards[4][c],ecards[5][c]})
end for
hands[11]=sort({ecards[1][1],ecards[2][2],ecards[3][3],ecards[4][4],ecards[5][5]})
hands[12]=sort({ecards[1][5],ecards[2][4],ecards[3][3],ecards[4][2],ecards[5][1]})
for c=1 to 12 do
if hands[c][1]!=-1 then
  suits[c]=floor((hands[c]-1)/13)+1
end if
  values[c]=remainder(hands[c],13)
  for cc=1 to 5 do
   if values[c][cc]=0 then
     values[c][cc]=13
   end if
  end for
  values[c]=sort(values[c])
   if values[c][1]=1 then
     if values[c][2]!=2 then
       for cc=1 to 5 do
        if values[c][cc]=1 then
          values[c][cc]=14
        end if
       end for
       values[c]=sort(values[c])
     end if
   end if
--end for
end for
end procedure

procedure bigcard()
sequence bcard
bcard=double_image(card)
mouse_pointer(0)
display_image({428,10},bcard)
mouse_pointer(1)
end procedure



function game()
shuffle()
polygon(7,1,{{0,0},{639,0},{639,479},{0,479}})
set_size(standard_size)
make_button(1,"Help",{380,370})
make_button(2,"High Scores",{512,370})
make_button(3,"New game",{380,420})
make_button(4,"Exit",{512,420})
set_size({112,30})
make_button(5,"New Player",{440,320})
oscore=0
for cc=1 to 5 do
for c=1 to 5 do
crd=53
--cnt=cnt+1
display_image({(c-1)*71,(cc-1)*96},cards[crd])
end for
end for
draw_line(0,{{355,0},{355,479}})
mouse_pointer(1)
mouse_events(LEFT_DOWN+LEFT_UP)
card=cards[deck[cnt]]
bigcard()
if length(player)=0 then
player=gbox()
end if
while cnt<26 do
mevent=get_mouse()
if sequence(mevent) then
--if event=0 then
  if mevent[1]=LEFT_DOWN then
   if mevent[2]<355 then
  x=floor(mevent[2]/71)*71
  y=floor(mevent[3]/96)*96
  tx=x/71+1
  ty=y/96+1
     if ecards[ty][tx]=-1 then
    mouse_pointer(0)
    display_image({x,y},card)
    mouse_pointer(1)
    ecards[ty][tx]=deck[cnt]
    cnt+=1
    card=cards[deck[cnt]]
    if cnt<26 then
      bigcard()
    end if
  end if
end if
test=check_button({1,2,3,4,5},mevent)
if test>0 then
if test=1 then
help()
elsif test=2 then
high_score()
elsif test=3 then
oscore=0
return 32
elsif test=4 then
return 27
elsif test=5 then
player=gbox()
end if
end if
eval()
tscore()
if score>oscore then
oscore=score
timage=build_text_image("Score",8,7,0)
timage=double_image(timage)
mouse_pointer(0)
display_image({460,225},timage)
mouse_pointer(1)
sscore=sprintf("%d",score)
timage=build_text_image(sscore,8,7,0)
timage=double_image(timage)
mouse_pointer(0)
display_image({500-floor(length(sscore)/2*16),265},timage)
mouse_pointer(1)
end if
end if
end if
end while
--eval()
--tscore()
if oscore>hscore[10][1] then -----------
hscore[10][1]=oscore -------------
hscore[10][2]=player
hscore=reverse(sort(hscore))
high_score()
end if
while 1 do
test=wait_button_down({1,2,3,4,5})
if test=1 then
help()
elsif test=2 then
high_score()
elsif test=3 then
oscore=0
return 32
elsif test=4 then
return 27
elsif test=5 then
player=gbox()
end if
end while
eval()
tscore()
end function

--main

test=graphics_mode(18)  --257<= needs different mouse routines for SVGA
while 1 do
test=game()
if test=27 then
mouse_pointer(0)
test=graphics_mode(-1)
eval()
tscore()
exit
end if
mouse_pointer(0)
end while
fn=open("psqscore.dat","wb")
bprint(fn,hscore)
close(fn)
--abort(0)

