include ez_read.e
include image.e
global function read_zig(sequence fname)
--returns {pal,image} or atom error
integer fn,x,y,num_colors,offset,offset2
sequence test,buffer,pal,image,junk
test=ez_info(fname)
if EZ_READ_ERROR() then
return EZ_READ_ERROR()
end if
fn=open(fname,"rb")
buffer=get_bytes(fn,9)
close(fn)
if equal(buffer[1..3],"ZIG") then
junk=buffer[4..5]&{0,0}
num_colors=bytes_to_int(junk)
junk=buffer[6..7]&{0,0}
x=bytes_to_int(junk)
junk=buffer[8..9]&{0,0}
y=bytes_to_int(junk)
 
buffer=ez_get("image")
if EZ_READ_ERROR() then
return EZ_READ_ERROR()
end if
offset=1
offset2=3
pal=repeat(repeat(0,3),num_colors)
for c=1 to num_colors do
pal[c]=buffer[offset..offset2]
offset+=3
offset2+=3
end for
offset=num_colors*3+1
offset2=offset+x-1
image=repeat(repeat(0,x),y)
for c=1 to y do
image[c]=buffer[offset..offset2]
offset+=x
offset2+=x
end for
EZ_ERROR=0
return {pal,image}
else
EZ_ERROR=20
return 20
end if
end function

global function ZIG_ERROR_STRING()
if EZ_ERROR=0 then
return "No errors"
else
return EZ_ERROR_STRING[EZ_ERROR]    
end if
end function


global function ZIG_ERROR()
return EZ_ERROR    
end function

global procedure CLEAR_ZIG_ERROR()
EZ_ERROR=0    
end procedure

